library ieee;
use ieee.std_logic_1164.all;

entity decoder is
port (i: in integer range 0 to 3;
      en: in std_logic;
      q: out std_logic_vector(0 to 3)
      );
end decoder;

architecture dataflow of decoder is
 signal temp: std_logic_vector( 0 to 3);
 
 begin
  with i select
   temp<= "1000" when 0,
          "0100" when 1,
          "0010" when 2,
          "0001" when others;
          
   q<= temp after 2 ns when en= '1' else
       "0000" after 2 ns;
       
 end dataflow;       
