library ieee;
use ieee.std_logic_1164.all;

entity mux4x1 is
 port (i0,i1,i2,i3: in std_logic;
 	s1,s0: in std_logic;
 	q: out std_logic);
 end mux4x1;
 
 architecture schematic of mux4x1 is
 
 component mux2x1 is
 port (a,b: in std_logic;
 	s: in std_logic;
 	q: out std_logic);
 end component;
 
 signal q0,q1: std_logic;
 
 begin
 
  m0: mux2x1 port map ( q => q0, a => i0, b=> i1, s => s0);
  m1: mux2x1 port map (i2,i3,s0,q1);
  m2: mux2x1 port map (q0,q1,s1,q);

 end schematic;
  
