library ieee;
use ieee.std_logic_1164.all;

entity mux4x1 is
port (a0,a1,a2,a3: in std_logic;
   	sel : in integer range 0 to 3;
   	q: out std_logic);
 end mux4x1;
 
 architecture seq of mux4x1 is
 
 begin
   process(a0,a1,a2,a3,sel)
    begin
      case sel is
       when 0 =>  q <= a0;
       when 1 =>  q <= a1;
       when 2 =>  q <= a2;
       when others => q<= a3;
      end case;
   end process;
 end seq;
 
