library ieee;
use ieee.std_logic_1164.all;

entity fsm is
port( rst,clk: in std_logic;
      I : in integer range 0 to 2;
      stato: out integer range 0 to 4);
 end fsm;
 
 architecture seq of fsm is
 begin
  process(rst,clk)
   variable s: integer range 0 to 4;
   begin
   
   if rst='1' then s:= 0;
   elsif clk'event and clk='0' then
          case s is
           when 0 => s:= 1;
           when 1 =>   case I is
           		when 0 => s:= 2;
           		when 1 => s:= 3;
           		when 2 => s:= 4;
           	       end case;
           when others => s:= 0;
          end case;
   end if;
   stato <= s;
  end process;
 end seq;
 	
